// #autoload
// #name        = EvCTFHud
// #version     = 2.0
// #date        = September 15th, 2002
// #author      = Evita
// #web         = http://www.tribesclans.com/evita
// #description = A T1 style CTF Hud.  You can use T1 or T2 point scoring style.  Full support for Team Rabbit!
// #category    = Evitas Scripts
// #config      = EvCTFHudConfig
// #include     = support/player_support.cs

if(isFile("prefs/EvPrefs.cs") && !$EvPrefsLoaded)
{
  	exec("prefs/EvPrefs.cs");
 	$EvPrefsLoaded = true;
}

if(!isObject(EvCTF))
{
	new ScriptObject(EvCTF)
	{
		class = EvCTF;
		version = "2.0";
	};
}

function EvCTF::Setup(%this)
{
	if(%this.setup)
	return;

	addMessageCallback('MsgTeamScore', EvHudCheckScores);
	addMessageCallback('MsgCTFFlagReturned', EvHudFlagReturned);
	addMessageCallback('MsgCTFFlagCapped', EvHudFlagCapped);
	addMessageCallback('MsgCTFFlagDropped', EvHudFlagDropped);
	addMessageCallback('MsgCTFFlagTaken', EvHudFlagTaken);
	addMessageCallback('MsgTeamRabbitFlagTaken', EvHudFlagTaken);
	addMessageCallback('MsgTeamRabbitFlagDropped', EvHudFlagDropped);
	addMessageCallback('MsgTeamRabbitFlagReturned', EvHudFlagReturned);

	new ShellFieldCtrl(EvCTFHud)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "relative";
		vertSizing = "relative";
		position = "5 5";
		extent = "140 40";
		minExtent = "8 8";
		visible = "1";

		new GuiMLTextCtrl(EvHudText1)
		{
			profile = "EvCTFHudProfileFriend";
			horizSizing = "relative";
			vertSizing = "relative";
			position = "25 5";
			extent = "194 16";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "1";
			maxChars = "30";
		};

		new GuiMLTextCtrl(EvHudText2)
		{
			profile = "EvCTFHudProfileFriend";
			horizSizing = "relative";
			vertSizing = "relative";
			position = "5 5";
			extent = "194 16";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "1";
			maxChars = "15";
		};

		new GuiMLTextCtrl(EvHudText3)
		{
			profile = "EvCTFHudProfileEnemy";
			horizSizing = "relative";
			vertSizing = "relative";
			position = "25 26";
			extent = "194 16";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "1";
			maxChars = "30";
		};

		new GuiMLTextCtrl(EvHudText4)
		{
			profile = "EvCTFHudProfileEnemy";
			horizSizing = "relative";
			vertSizing = "relative";
			position = "5 26";
			extent = "194 16";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "1";
			maxChars = "15";
		};
	};

	playgui.add(EvCTFHud);


	EvCTFTrans.setValue($EvPrefs::EvCTF::Trans);
	EvCTFScore.setValue($EvPrefs::EvCTF::T2Style);
	EvCTFHud.ToggleTrans();

	%this.setup = true;
}

function EvCTF::Reset(%this)
{
	if(PlayerList.getTeamByID(playerlist.getmyid()) == 0){
	%this.updateSchedule = %this.schedule(1000, Reset);
	return;}

	$MyTeam = PlayerList.getTeamByID(playerlist.getmyid());

	$EvHudflagLocation[1] = "<Home>";
	$EvHudflagLocation[2] = "<Home>";
	$FT1Score = "0";
	$ET1Score = "0";
	$Ftimer = "46";
	$Etimer = "46";
	$EDropped = "0";
	$FDropped = "0";

 	commandToServer('getScores');

	EvCTF.Update();
}

function EvCTF::Update(%this) 
{
	if($EvPrefs::EvCTF::T2Style)
	{
		$EvHudcapScore[1] = $FT2Score;
		$EvHudcapScore[2] = $ET2Score;
	}
	else
	{
		$EvHudcapScore[2] = $FT1Score;
		$EvHudcapScore[1] = $ET1Score;
	}

	EvHudText1.setValue($EvHudflagLocation[1]);
	EvHudText2.setValue($EvHudcapScore[1]);
	EvHudText3.setValue($EvHudflagLocation[2]);
	EvHudText4.setValue($EvHudcapScore[2]);
}

function EvHudFlagTaken(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
   	%taker = detag(%a4);  
   	%flagIndex = %a3;

   	if(%flagIndex == PlayerList.getTeamByID(playerlist.getmyid())){
		$FDropped = "0";
		$EvHudflagLocation[1] = "<" @ %taker @ ">";}
   	else{
		$EDropped = "0";
		$EvHudflagLocation[2] = "<" @ %taker @ ">";}     

 	commandToServer('getScores');
}	   

function EvHudFlagDropped(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
   	%index = detag(%a3);

   	if(%index == PlayerList.getTeamByID(playerlist.getmyid())){
		$FDropped = "1";
		$Ftimer = "46";
		EvCTF.FTimer();}
   	else{
		$EDropped = "1";
		$Etimer = "46";
		EvCTF.ETimer();}
}	   

function EvHudFlagCapped(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
   	$TeamIDCapped = detag(%a3);

   	if($TeamIDCapped == $MyTeam)
	{
		$FDropped = "0";
		$EvHudflagLocation[1] = "<Home>";
		$FT1Score++;
	}
   	else
	{
		$EDropped = "0";
		$EvHudflagLocation[2] = "<Home>";
		$ET1Score++;
	}

 	commandToServer('getScores');
}	   

function EvHudFlagReturned(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
  	%index = detag(%a3);

   	if(%index == PlayerList.getTeamByID(playerlist.getmyid())){
		$FDropped = "0";
		$EvHudflagLocation[1] = "<Home>";}
   	else{
		$EDropped = "0";
		$EvHudflagLocation[2] = "<Home>";}

	EvCTF.Update();
}


function EvHudCheckScores(%msgType, %msgString, %team, %teamScore)
{
	if(%team == $MyTeam)
	$FT2Score = %teamScore;
	else
	$ET2Score = %teamScore;

	EvCTF.Update();
}

function EvCTFHud::ToggleTrans(%this)
{
	%this.profile = $EvPrefs::EvCTF::Trans ? GuiConsoleProfile : GuiChatBackProfile;
	playGui.remove(%this);
	playGui.add(%this);
}   

function EvCTF::FTimer(%this)
{
	if($Ftimer <= 0 ){
	$FDropped = "0";
	$Ftimer = "46";}

	if($FDropped == 1){

	if(isEventPending(%this.FriendlySchedule))
	cancel(%this.FriendlySchedule);

	$Ftimer--;
	$EvHudflagLocation[1] = "<Dropped: " @ $Ftimer @ ">";
   	EvCTF.Update();
	%this.FriendlySchedule = %this.schedule(1000, FTimer);}

        else{
	$FDropped = "0";
	$Ftimer = "46";}
}

function EvCTF::ETimer(%this)
{
	if($Etimer <= 0 ){
	$EDropped = "0";
	$Etimer = "46";}

	if($EDropped == 1){

	if(isEventPending(%this.EnemySchedule))
	cancel(%this.EnemySchedule);

	$Etimer--;
	$EvHudflagLocation[2] = "<Dropped: " @ $Etimer @ ">";
   	EvCTF.Update();
	%this.EnemySchedule = %this.schedule(1000, ETimer);}

        else{
	$EDropped = "0";
	$Etimer = "46";}
}

package EvCTF 
{

function LoadingGui::onWake(%this)
{
   	EvCTF.Reset();
	EvCTF.Setup();

	parent::onWake(%this);
}

function clientCmdMissionEnd(%seq)
{
   	EvCTF.Reset();

   	parent::clientCmdMissionEnd(%seq);
}

function PlayGui::onWake(%this)
{
	if(isObject(HM) && isObject(HudMover))
	hudmover::addhud(EvCTFHud, "EvCTFHud");

	EvCTF.playGui = true;

	parent::onWake(%this);
}

function PlayGui::onSleep(%this)
{
	EvCTF.playGui = false;

	parent::onSleep(%this);
}

function quit()
{
	if(!$EvPrefsSaved)
	{
		export("$EvPrefs::*", "prefs/EvPrefs.cs", false);
		$EvPrefsSaved = true;
	}

	parent::quit();
}

};

activatePackage(EvCTF);

new GuiControlProfile ("EvCTFHudProfileFriend")
{
	fontType = $ShellBoldFont;
	fontSize = 16;
	fontColor = "0 255 0";
};
new GuiControlProfile ("EvCTFHudProfileEnemy")
{
	fontType = $ShellBoldFont;
	fontSize = 16;
	fontColor = "255 0 0";
};

new GuiControl(EvCTFHudConfig) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "179 115";
		extent = "294 252";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "EvCTFHud";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";
	};
	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "201 145";
		extent = "249 200";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
	};
	new ShellToggleButton(EvCTFTrans) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "251 199";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$EvPrefs::EvCTF::Trans";
		command = "EvCTFHud.ToggleTrans();";
		helpTag = "0";
		text = "Transparant HUD";
		longTextBuffer = "0";
		maxLength = "255";
	};
	new ShellToggleButton(EvCTFScore) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "251 247";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$EvPrefs::EvCTF::T2Style";
		command = "EvCTF.Update();";
		helpTag = "0";
		text = "T2 Point Scoring";
		longTextBuffer = "0";
		maxLength = "255";
	};
};
